source ROOTWINDOW.tcl
source SLFCONSTS.tcl
source MATH.tcl
source SLIDEUI.tcl

set FS_GRID_OFF 0
set FS_GRID_UNBREAKABLE 1
set FS_GRID_BREAKABLE 2
set FS_GRID_PRIZE 3

proc CreateFSGridTypeFrame { name parent } {
    set root $parent

    set gridTypeList [list FS_GRID_OFF FS_GRID_UNBREAKABLE FS_GRID_BREAKABLE FS_GRID_PRIZE] 
    set enumList [CreateSLIDEEnumList $gridTypeList]

    global FS_GRID_BREAKABLE

    return [CreateRadioButtonFrame $name $root gridType "Grid Type" $FS_GRID_BREAKABLE $enumList]
}

set FS_PRIZE_OFF 0
set FS_PRIZE_ON 1

proc CreateFSPrizeTypeFrame { name parent } {
    set root $parent

    set prizeTypeList [list FS_PRIZE_OFF FS_PRIZE_ON] 
    set enumList [CreateSLIDEEnumList $prizeTypeList]

    global FS_PRIZE_ON

    return [CreateRadioButtonFrame $name $root prizeType "Prize Type" $FS_PRIZE_ON $enumList]
}

proc CreateFSGridTileUI { parent name } {

    if { $parent == {} } {
	set root ".slf_[subst $name]"
    } elseif { $parent == "." } {
	set root ".slf_[subst $name]"
    } else {
	set root "$parent.slf_[subst $name]"
    }

    toplevel $root

    ##################################################
    # Grid Type

    set gridTypeFrame [CreateFSGridTypeFrame $name $root]

    ##################################################
    # Prize Type

    set prizeTypeFrame [CreateFSPrizeTypeFrame $name $root]

    pack $gridTypeFrame $prizeTypeFrame -side top -fill x
}
