proc PrintBinary { v bits } {
    set bin ""

    for {incr bits -1} {$bits >= 0} {incr bits -1} {
	set bin "$bin [expr ($v >> $bits) & 1]"
    }
    puts $bin
}

proc PrintBinaryValues { values bits } {
    foreach value $values {
	PrintBinary $value $bits
    }
}

proc CountOnes { v } {
    set i 0

    while { $v != 0 } {
	incr i
	set v [expr $v & ($v - 1)]
    }

    return $i
}

proc SwapMask { v mask } {
    return [expr (~($v & $mask)) & ($v | $mask)]
}

proc GrayCodes { bits } {
    set pShifts 0

    for {set i 1} {$i < $bits} {incr i} {
	set pShifts "$pShifts $i $pShifts"
    }

    set value 0
    set values "0"

    #PrintBinary $value $bits

    foreach shift $pShifts {
	set value [SwapMask $value [expr 1 << $shift]]
	set values "$values $value"
    }

    return $values
}

proc HilbertCodesHelper { bits offset value } {

    if { $offset == 0 } {
	return $value
    }

    set values ""

    set tmp [expr ($value >> ($offset+1)) & 1]
    set offset [expr $offset - 2]
    set iShifts "31 [expr $offset+(!$tmp)] [expr $offset+$tmp] [expr $offset+(!$tmp)]"
    
    foreach iShift $iShifts {
	puts "iShift = $iShift"
	PrintBinary [expr 1 << $iShift] 4
	set value [expr [SwapMask $value [expr 1 << $iShift]] & (~(1<<31))]
	puts "value ="
	PrintBinary $value 4
	set values "$values [HilbertCodesHelper $bits $offset $value]"
    }

puts "Values = $values"
    return $values
}

proc GrayCodesHelper { bits offset } {

    global value

    if { $offset == 0 } {
	return $value
    }

    set values ""

    set offset [expr $offset - 1]
    set iShifts "31 $offset"
    
    foreach iShift $iShifts {
	puts "iShift = $iShift"
	PrintBinary [expr 1 << $iShift] 4
	set value [expr [SwapMask $value [expr 1 << $iShift]] & (~(1<<31))]
	puts "value ="
	PrintBinary $value 4
	set values "$values [GrayCodesHelper $bits $offset]"
    }

puts "Values = $values"
    return $values
}

proc HilbertCodes { } {
    set bits 4

    set value 0
    set values ""

    set jShifts "31 2 3 2"

    foreach jShift $jShifts {

	puts "jShift = $jShift"
	PrintBinary [expr 1 << $jShift] 4

	set value [expr [SwapMask $value [expr 1 << $jShift]] & (~(1<<31))]

	#set tmp [expr [CountOnes [expr $value >> 2]] & 1]
	set tmp [expr [expr $value >> 2] & 1]
	set iShifts "31 [expr !$tmp] $tmp [expr !$tmp]"

	foreach iShift $iShifts {
	    puts "iShift = $iShift"
	    PrintBinary [expr 1 << $iShift] 4
	    set value [expr [SwapMask $value [expr 1 << $iShift]] & (~(1<<31))]
	    puts "value ="
	    PrintBinary $value 4
	    set values "$values $value"
	}
    }


puts "Values = $values"
    return $values
}


#for {set i 0} {$i < 8} {incr i} {
#    puts "$i: bits = [CountOnes $i]"
#    PrintBinary $i 3
#}

#set grayCodes [GrayCodes 3]
#puts "grayCodes = $grayCodes"
#PrintBinaryValues $grayCodes 3

#set hilbertCodes [HilbertCodes]
#puts "hilbertCodes = $hilbertCodes"
#PrintBinaryValues $hilbertCodes 4

set value 0
set hilbertCodes [GrayCodesHelper 4 4]
puts "hilbertCodes = $hilbertCodes"
PrintBinaryValues $hilbertCodes 4

set grayCodes [GrayCodes 4]
puts "grayCodes = $grayCodes"
PrintBinaryValues $grayCodes 4

