set SLF_PI 3.1415927


proc GenerateOurTorus { {pcName "OurTorus"}     \
                        {fR1 4.0}            \
                        {fR2 2.0}            \
                        {fR3 1.0}           \
                        {iAlphaSamples 16}   \
			{iAlphaRevolutions 3}\
                        {iBetaSamples 16}    \
			{iBetaRevolutions 1} \
			{iGamaSlices 16} } {

    global SLF_PI

    set fDeltaAlpha [expr 2.0 * $SLF_PI / $iAlphaSamples]
    set fDeltaBeta [expr 2.0 * $SLF_PI * $iBetaRevolutions / ($iBetaSamples * $iAlphaRevolutions)]
    set fDeltaGama [expr 2.0 * $SLF_PI / $iGamaSlices]

    set fAlpha 0
    set fBeta  0

    slide group "g[subst $pcName]"

    set listSpheres ""

    slide sphere "Chris" -radius [subst $fR3] -zmin [expr -1 * $fR3] -zmax [subst $fR3] -thetamax 360.0 -zslices [subst $iGamaSlices]

    for { set j 0 } { $j <= ($iAlphaRevolutions * $iAlphaSamples) } { incr j } {

        puts "j = $j"

        slide instance "g[subst $pcName]" "Chris" -id "sph[subst $j]" \
          -xforms { {translate [expr ($fR1 + ($fR2 * cos($fBeta))) * cos($fAlpha)] [expr ($fR1 + ($fR2 * cos($fBeta))) * sin($fBeta)] [expr sin($fBeta)] } }
	    
        set listSpheres "$listSpheres i[subst $pcName]_[subst $j]"

	set fAlpha [expr $fAlpha + $fDeltaAlpha]
	set fBeta [expr $fBeta + $fDeltaBeta]
    } 

    #set iFaceID 0
    #set listFaces ""


    # The following loop goes back through the vertices and makes
    # a slide face for each triangle of vertices on the surface.
    # At the same time it is maintaining a list of the names of the
    # faces it is making so that we can make a slide object with that
    # list (actually a long string).

    # Create 

    #for { set i 1 } { $i <= ($iAlphaRevolutions * $iAlphaSamples) } { incr i } #{
	#for { set j 1 } { $j <= $iGamaSlices } { incr j } {

            # This adds a face to the slide scene
	    #slide face "f[subst $pcName]_[subst $iFaceID]" [list "p[subst $pcName]_[expr $i]_[expr $j - 1]" "p[subst $pcName]_[expr $i - 1]_[expr $j]" "p[subst $pcName]_[expr $i - 1]_[expr $j - 1]"]

            # This adds the name of the face to the string of faces.
	    #set listFaces "$listFaces f[subst $pcName]_[subst $iFaceID]"
	    #incr iFaceID


            # This adds a face to the slide scene
	    #slide face "f[subst $pcName]_[subst $iFaceID]" [list "p[subst $pcName]_[expr $i]_[expr $j]" "p[subst $pcName]_[expr $i - 1]_[expr $j]" "p[subst $pcName]_[expr $i]_[expr $j - 1]"]

            # This adds the name of the face to the string of faces.
	    #set listFaces "$listFaces f[subst $pcName]_[subst $iFaceID]"
	    #incr iFaceID
	    #}
    #}

    # Finally we output the object with the string of face identifiers 
    # we made earlier.  Note that we call it o+pcName

}
